var Promise = require('promise');
var configjs = require('./config');
module.exports = function (RED) {

    function ArnidosmarthomeCallSceneNode(config) {
        RED.nodes.createNode(this, config);

        console.debug("ArnidosmarthomeCallSceneNode")
        console.debug(config);

        this.conf = configjs.getNode();
        this.name = config.name;
        this.device = config.device;
        this.channel = config.channel;
        

        this.reportState = function (original) {
            let msg = {
                topic: this.device,
                payload: this.name
            };

            if (original !== undefined) {
                Object.assign(msg, original);
            }

            this.send(msg);
        }

        this.setState = function (value) {
            Object.assign(this.state, value);

            this.reportState();
        }
        this.updateStatus = function (currentStatus) {
            //if (this.state.level != currentStatus) {
            this.state = currentStatus;
            this.reportState();
            //}
        }

        if (this.conf && this.device) {
            const callback = (evt) => {
                console.debug("String Device(" + this.name + ") Callback called");
                console.debug(evt);


                if (evt["state"] && evt["state"] != "") {
                    if (evt["state"].toLowerCase() == "on") {
                        this.updateStatus(evt["state"]);
                    }
                }
            }

            this.conf.registerCallback(this, this.channel, callback);

            this.conf.getDeviceStatus(this.channel).then((status) => {
                console.debug("Decimal Device(" + this.name + ") Status Refreshed");

                let state = {};

                if (status["lastState"] !== undefined) {
                    state = (status["lastState"]);
                }
                //this.updateStatus(state.level)

                //this.setState(state);
            }).catch(err => {
                console.error("Ops... error getting device state (LevelDevice)");
                console.error(err);
            });

            // this.on('input', msg => {
            //     console.debug("Input Message Received");
            //     console.log(msg);
            //     if (this.mission == "2") {//cihazı kontrol et
            //         if (this.setvalue != "") {
            //             this.conf.executeDeviceCommand({
            //                 channelUid: this.channel,
            //                 commandType: "String",
            //                 command: this.setvalue
            //             }).then((ret) => {
            //                 this.updateStatus(com);
            //             }).catch((ret) => {
            //                 console.error("Error updating device");
            //             });
            //         }
            //     }
            // });

            this.on('close', () => {
                console.debug("Closed");
                this.conf.unregisterCallback(this, this.device, callback);
            });
        }
    }

    RED.nodes.registerType("arnidosmarthome-node-call-scene", ArnidosmarthomeCallSceneNode);

};
