var Promise = require('promise');
var configjs = require('./config');
// const configjs = require('./arnidosmarthome-config');

module.exports = function (RED) {

    function ArnidosmarthomeOnOffNode(config) {
        RED.nodes.createNode(this, config);
        this.conf = configjs.getNode();
        this.name = config.name;
        this.device = config.device;
        this.channel = config.channel;
        this.setvalue = config.setvalue;
        this.mission = config.mission;

        this.currentStatus = 0;


        this.reportStatus = function (original) {
            let msg;
            console.debug(this.currentStatus);
            if (this.currentStatus == 1) {
                msg = [{
                    topic: "device",
                    payload: this.currentStatus
                    // payload: {
                    //     deviceId: this.channel,
                    //     deviceType: "switch",
                    //     name: this.name,
                    //     value: this.currentStatus
                    // }
                }, undefined]
            }
            else {
                msg = [undefined, {
                    topic: "device",
                    payload: this.currentStatus
                    // payload: {
                    //     deviceId: this.channel,
                    //     deviceType: "switch",
                    //     name: this.name,
                    //     value: this.currentStatus
                    // }
                }]
            }

            if (original !== undefined) {
                Object.assign(msg, original);
            }

            this.send(msg);
        }

        this.updateStatus = function (currentStatus) {
            //if (this.currentStatus != currentStatus) {
            this.currentStatus = currentStatus;
            this.reportStatus();
            //}
        }

        //if (this.conf && this.device && this.channel) {
        const callback = (evt) => {
            console.debug("OnOffDevice(" + this.name + ") Callback called");
            console.debug(evt);
            if (evt["state"] && evt["state"] != "") {
                if (this.mission == "1") { //senaryo başlatıcı ise çıkıştan akış başlatacak
                    this.updateStatus((evt["state"].toLowerCase() === "on" ? 1 : 0));
                }
                else {
                    this.currentStatus = (evt["state"].toLowerCase() === "on" ? 1 : 0);
                }
            }
        }

        this.conf.registerCallback(this, this.channel, callback);

        this.conf.getDeviceStatus(this.channel).then((status) => {
            console.debug("OnOffDevice(" + this.name + ") Status Refreshed");

            this.currentStatus = status["lastState"].toLowerCase() == "on" ? 1 : 0;
            // if (current) {
            //     this.updateStatus((current.toLowerCase() == "on" ? 1 : 0));
            // }
        }).catch(err => {
            console.error("Ops... error getting device state (OnOffDevice)");
            console.error(err);
        });

        this.on('input', msg => {
            console.debug("Input Message Received");
            console.debug(msg);
            if (this.setvalue != "") {
                if (this.setvalue == "2") {//reverse state
                    this.conf.executeDeviceCommand({
                        channelUid: this.channel,
                        commandType: "OnOff",
                        command: (this.currentStatus == 1 ? "OFF" : "ON")
                    }).then((ret) => {
                        this.updateStatus(this.currentStatus == 1 ? 0 : 1);
                    }).catch((ret) => {
                        console.error("Error updating device", ret);
                    });
                }
                else {
                    this.conf.executeDeviceCommand({
                        channelUid: this.channel,
                        commandType: "OnOff",
                        command: (this.setvalue == "1" ? "ON" : "OFF")
                    }).then((ret) => {
                        this.updateStatus(parseInt(this.setvalue));
                    }).catch((ret) => {
                        console.error("Error updating device", ret);
                    });
                }
            }
            else if (msg) {
                this.reportStatus();
            } else if (msg.topic === "update") {
                this.reportStatus(msg);
            }
        });

        this.on('close', () => {
            console.debug("Closed");
            this.conf.unregisterCallback(this, this.channel, callback);
        });
        //}
    }

    RED.nodes.registerType("arnidosmarthome-node-onoff", ArnidosmarthomeOnOffNode);

};
