var Promise = require('promise');
var configjs = require('./config');
module.exports = function (RED) {

    function ArnidosmarthomeStringNode(config) {
        RED.nodes.createNode(this, config);

        console.debug("ArnidosmarthomeStringNode")
        console.debug(config);

        this.conf = configjs.getNode();
        this.name = config.name;
        this.device = config.device;
        this.channel = config.channel;
        this.setvalue = config.setvalue;
        this.mission = config.mission;
        this.operator = config.operator;

        this.currentLevel = 0;

        this.state = "";

        this.reportStatus = function (original) {
            let msg = {
                topic: this.device,
                payload: this.state
            };

            if (original !== undefined) {
                Object.assign(msg, original);
            }

            this.send(msg);
        }

        this.setState = function (value) {
            Object.assign(this.state, value);

            this.reportStatus();
        }
        this.updateStatus = function (currentStatus) {
            //if (this.state.level != currentStatus) {
            this.state = currentStatus;
            this.reportStatus();
            //}
        }

        if (this.conf && this.device) {
            const callback = (evt) => {
                console.debug("String Device(" + this.name + ") Callback called");
                console.debug(evt);


                if (evt["state"] && evt["state"] != "") {
                    // if (this.mission == "1") {//senaryo başlatıcı
                    //     this.updateStatus(evt["state"]);
                    // }
                    // else {
                    this.state = evt["state"];
                    // }
                }
            }

            this.conf.registerCallback(this, this.channel, callback);

            this.conf.getDeviceStatus(this.channel).then((status) => {
                console.debug("Decimal Device(" + this.name + ") Status Refreshed");

                let state = {};

                if (status["lastState"] !== undefined) {
                    this.state = (status["lastState"]);
                }
                //this.updateStatus(state.level)

                //this.setState(state);
            }).catch(err => {
                console.error("Ops... error getting device state (LevelDevice)");
                console.error(err);
            });

            this.on('input', msg => {
                console.debug("Input Message Received");
                console.log(msg);
                if (this.mission == "0") {//koşul
                    let ret = this.checkCondition();
                    if (ret) {
                        this.reportStatus();
                    }
                }
                else if (this.mission == "2") {//cihazı kontrol et
                    if (this.setvalue != "") {
                        this.conf.executeDeviceCommand({
                            channelUid: this.channel,
                            commandType: "String",
                            command: this.setvalue
                        }).then((ret) => {
                            this.updateStatus(com);
                        }).catch((ret) => {
                            console.error("Error updating device");
                        });
                    }
                }
            });
            this.checkCondition = function () {
                let ret = false;
                console.log(this.operator);
                if (this.operator != "") {
                    switch (this.operator) {
                        case "0":// =
                            if (this.state == this.setvalue)
                                ret = true;
                            break;
                        case "1":// !=
                            if (this.state != this.setvalue)
                                ret = true;
                            break;
    
                        default:
                            break;
                    }
                }
                else {
                    return true;
                }
                return ret;
            }
            this.on('close', () => {
                console.debug("Closed");
                this.conf.unregisterCallback(this, this.device, callback);
            });
        }
    }

    RED.nodes.registerType("arnidosmarthome-node-string", ArnidosmarthomeStringNode);

};
