var Promise = require('promise');
var configjs = require('./config');
module.exports = function (RED) {

    function ArnidosmarthomeTriggerNode(config) {
        RED.nodes.createNode(this, config);

        console.debug("ArnidosmarthomeTriggerNode")
        console.debug(config);

        this.conf = configjs.getNode();
        this.name = config.name;
        this.device = config.device;
        this.channel = config.channel;
        this.setvalue = config.setvalue;

        this.currentStatus = -1;

        this.reportStatus = function (original) {
            let msg = [undefined, undefined, undefined, undefined];
            msg[parseInt(this.currentStatus)] = {
                topic: "device",
                payload: {
                    deviceId: this.channel,
                    deviceType: "trigger",
                    name: this.name
                }
            }

            if (original !== undefined) {
                Object.assign(msg, original);
            }

            this.send(msg);
        }

        this.updateStatus = function (currentStatus) {
            this.currentStatus = currentStatus;
            this.reportStatus();
        }

        if (this.conf && this.device && this.channel) {
            const callback = (evt) => {
                console.debug("TriggerDevice(" + this.name + ") Callback called");
                console.debug(evt);
                if (evt["event"] && evt["event"] != "") {
                    let event;
                    switch (evt["event"].toLowerCase()) {
                        case "pressed":
                            event = 0;
                            break;
                        case "released":
                            event = 1;
                            break;
                        case "double_pressed":
                            event = 2;
                            break;
                        case "long_pressed":
                            event = 3;
                            break;
                        default:
                            event = 0;
                            break;
                    }
                    this.updateStatus(event.toString());
                }
            }

            this.conf.registerCallback(this, this.channel, callback);

            // this.conf.getDeviceStatus(this.channel).then((status) => {
            //     console.debug("Trigger(" + this.name + ") Status Refreshed");

            //     current = status["lastState"];
            //     if (current) {
            //         this.updateStatus((current.toLowerCase() == "on" ? 1 : 0));
            //     }
            // }).catch(err => {
            //     console.error("Ops... error getting device state (OnOffDevice)");
            //     console.error(err);
            // });

            this.on('input', msg => {
                console.debug("Input Message Received");
                if (this.setvalue != "") {
                    this.updateStatus(this.setvalue);

                    // this.conf.executeDeviceCommand({
                    //     channelUid: this.channel,
                    //     commandType: "OnOff",
                    //     command: (this.setvalue == "1" ? "ON" : "OFF")
                    // }).then((ret) => {
                    //     this.updateStatus(parseInt(this.setvalue));
                    // }).catch((ret) => {
                    //     console.error("Error updating device");
                    // });

                }
            });

            this.on('close', () => {
                console.debug("Closed");
                this.conf.unregisterCallback(this, this.channel, callback);
            });
        }
    }

    RED.nodes.registerType("arnidosmarthome-node-trigger", ArnidosmarthomeTriggerNode);

};
